<!doctype html>
<html class="no-js" lang="en">
<head>
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta charset="utf-8">

<title>Active Directory Password Checker</title>

<!-- Bootstrap core CSS -->
<link href="css/bootstrap.min.css" rel="stylesheet">

<!-- Custom styles for this template -->
<link href="css/dashboardr2x.css" rel="stylesheet">
<script type="text/javascript" src="js/jquery-2.1.1.min.js"></script>
</head>
<body>
<br>
<form method="post" action="mypwdchk.php">
	<table><tr>
		<td colspan="3">1. Enter your username and click the Submit button</td>
	</tr><tr>
    		<td width="80px">Username</td><td width="150px"><input type="text" name="username" id="username" value="<?php echo $_POST["username"] ?>"></td><td><input type="submit" value="Submit" name="submit"></td>
	</tr><tr>
		<td colspan="3" id="ad_warning"></td>
	</tr><tr>
		<td colspan="3" height="25px"></td>
	</tr><tr>
                <td colspan="3">2. Type the password of your choice to check if it is compliant with the complexity rules below</td>
	</tr><tr>
    		<td width="80px">Password</td><td width="150px"><input type="text" name="password" id="password"></td>
	</tr></table>
</form>
<br>
<?php
        $ini_array = parse_ini_file("config.ini");
        $config_totChars = $ini_array['totChars'];
        $config_lowerChars = $ini_array['lowerChars'];
        $config_upperChars = $ini_array['upperChars'];
        $config_numChars = $ini_array['numChars'];
        $config_specChars = $ini_array['specChars'];
	echo "<script>var totChars_req = ".$config_totChars.";</script>";
	echo "<script>var lowerChars_req = ".$config_lowerChars.";</script>";
	echo "<script>var upperChars_req = ".$config_upperChars.";</script>";
	echo "<script>var numChars_req = ".$config_numChars.";</script>";
	echo "<script>var specChars_req = ".$config_specChars.";</script>";
?>
<table class="table table-striped table-bordered table-hover table-condensed">
        <tr>
                <th>Description</th><th>Count</th><th>Requirements</th>
        </tr>
	<tr id="pwdlength_row">
		<td>Be at least <?php echo $config_totChars; ?> characters in length</td><td id="pwdlength_cell"></td><td><?php echo $config_totChars; ?></td>
	</tr>
	<tr id="lower_row">
		<td>English lowercase characters (a through z)</td><td id="lower_cell"></td><td><?php echo $config_lowerChars; ?></td>
	</tr>
	<tr id="upper_row">
		<td>English uppercase characters (A through Z)</td><td id="upper_cell"></td><td><?php echo $config_upperChars; ?></td>
	</tr>
	<tr id="num_row">
		<td>Base 10 digits (0 through 9)</td><td id="num_cell"></td><td><?php echo $config_numChars; ?></td>
	</tr>
	<tr id="spec_row">
		<td>Non-alphabetic characters (for example, &#233;, &#231;, !, $, #, %)</td><td id="spec_cell"></td><td><?php echo $config_specChars; ?></td>
	</tr>
	<tr id="forbidden_row">
		<td>Not contain the user's account name or parts of the <br>user's full name that exceed two consecutive characters</td><td id="forbidden_cell"></td><td id="forbidden_str_cell"></td>
	</tr>

</table>

<br>
<span id="final">Your Password is </span><span id="final_result"></span>

<?php
function getdn($ini_array) {
	$config_accountSuffix = $ini_array['accountSuffix'];
	$config_baseDn = $ini_array['baseDn'];
	$config_domainControllers = $ini_array['domainControllers'];

	$user = $ini_array['user'];
	$pass = $ini_array['pass'];

	include (dirname(__FILE__) . "/adLDAP/src/adLDAP.php");
	$adldap = new adLDAP(array('use_tls'=>1, 'base_dn'=>$config_baseDn, 'account_suffix'=>$config_accountSuffix, 'domain_controllers'=>array($config_domainControllers)));
	$authUser = $adldap->user()->authenticate($user, $pass);
	if ($authUser == true) {
		$userinfo = $adldap->user()->info($_POST["username"], array("mail","displayname"));
		if ($userinfo) {
			echo "<script>document.getElementById('password').disabled = false;</script>";
			echo "<script>document.getElementById('password').focus();</script>";
			echo "<script>var displayname = '".$userinfo[0]["displayname"][0]."';</script>";
			echo "<script>var samaccountname = '".$_POST["username"]."';</script>";
	
			echo "<script>var displayname_arr = displayname.split(/,| |;|-|_/);";
			echo "for (var i=displayname_arr.length-1; i>=0; i--) {";
			echo "	if (displayname_arr[i].length < 3) {";
			echo "		displayname_arr.splice(i,1);";
			echo "	}";
			echo "}";
			echo "displayname_arr.splice(0,0,samaccountname);</script>";
			echo "<script>document.getElementById('forbidden_str_cell').innerHTML = displayname_arr;</script>";
			echo "<script>document.getElementById('ad_warning').innerHTML='';</script>";
			echo "<script>document.getElementById('ad_warning').style.backgroundColor = '';</script>";
		}
		else {
			echo "<script>document.getElementById('password').disabled = true;</script>";
			echo "<script>document.getElementById('ad_warning').innerHTML='Username not found. Please enter a valid Active Directory username';</script>";
			echo "<script>document.getElementById('ad_warning').style.backgroundColor = 'LightCoral';</script>";
		}
	}
}

if(isset($_POST['submit'])) {
   	getdn($ini_array);
} 
if(is_null($_POST['username'])) {
	echo "<script>document.getElementById('username').focus();</script>";
}

?>

<script>
	$('#password').on('input', function() {
		var lowerChars = /[^a-z]/g;
		var upperChars = /[^A-Z]/g;
		var numChars = /[^0-9]/gi;


		var pwd2chk = document.getElementById("password").value;
	
		var req1 = 0;
		var req2 = 0;
		var req3 = 0;
		var req4 = 0;
		var req = 0;
	
		var forbidden_str_arr = [];
	
		$.each( displayname_arr, function( key, value ) {
			var re = new RegExp(value, 'gi');
			var result = pwd2chk.match(re);
			if (!(result)){
				req3 += 1;
				console.log(value);	
				forbidden_str_arr.push(value);
			}
			else {
				forbidden_str_arr.push("<font style='background-color:LightCoral;'>"+value+"</font>");
			}
		});
		document.getElementById('forbidden_str_cell').innerHTML = forbidden_str_arr.join(",");

		if (req3 == displayname_arr.length) {
			document.getElementById("forbidden_cell").innerHTML="OK"
			document.getElementById("forbidden_cell").style.backgroundColor = "PaleGreen";
			$("#forbidden_row").removeClass();
			$("#forbidden_row").addClass('success');
			req4 += 10;	
		}
		else {
			document.getElementById("forbidden_cell").innerHTML="NOT OK"
			document.getElementById("forbidden_cell").style.backgroundColor = "LightCoral";
			$("#forbidden_row").removeClass();
			$("#forbidden_row").addClass('danger');
		}
		
		
		var lowerChars_length = pwd2chk.replace(lowerChars, "").length;
		var upperChars_length = pwd2chk.replace(upperChars, "").length;
		var numChars_length = pwd2chk.replace(numChars, "").length;
		var specChars_length = pwd2chk.length - (lowerChars_length + upperChars_length + numChars_length);
		var totChars_length = pwd2chk.length;

		document.getElementById("pwdlength_cell").innerHTML = pwd2chk.length;
		document.getElementById("lower_cell").innerHTML = lowerChars_length;
		document.getElementById("upper_cell").innerHTML = upperChars_length;
		document.getElementById("num_cell").innerHTML = numChars_length;
		document.getElementById("spec_cell").innerHTML = specChars_length;
		
		if (lowerChars_length >= lowerChars_req) {
			document.getElementById("lower_cell").style.backgroundColor = "PaleGreen";
			$("#lower_row").removeClass();
			$("#lower_row").addClass('success');
			req2 += 1;
		}		
		else {
			document.getElementById("lower_cell").style.backgroundColor = "LightCoral";
			$("#lower_row").removeClass();
			$("#lower_row").addClass('danger');
		}

		if (upperChars_length >= upperChars_req) {
			document.getElementById("upper_cell").style.backgroundColor = "PaleGreen";
			$("#upper_row").removeClass();
			$("#upper_row").addClass('success');
			req2 += 1;
		}		
		else {
			document.getElementById("upper_cell").style.backgroundColor = "LightCoral";
			$("#upper_row").removeClass();
			$("#upper_row").addClass('danger');
		}

		if (numChars_length >= numChars_req) {
			document.getElementById("num_cell").style.backgroundColor = "PaleGreen";
			$("#num_row").removeClass();
			$("#num_row").addClass('success');
			req2 += 1;
		}		
		else {
			document.getElementById("num_cell").style.backgroundColor = "LightCoral";
			$("#num_row").removeClass();
			$("#num_row").addClass('danger');
		}

		if (specChars_length >= specChars_req) {
			document.getElementById("spec_cell").style.backgroundColor = "PaleGreen";
			$("#spec_row").removeClass();
			$("#spec_row").addClass('success');
			req2 += 1;
		}		
		else {
			document.getElementById("spec_cell").style.backgroundColor = "LightCoral";
			$("#spec_row").removeClass();
			$("#spec_row").addClass('danger');
		}

		if (totChars_length >= totChars_req) {
			document.getElementById("pwdlength_cell").style.backgroundColor = "PaleGreen";
			$("#pwdlength_row").removeClass();
			$("#pwdlength_row").addClass('success');
			req1 += 10;
		}		
		else {
			document.getElementById("pwdlength_cell").style.backgroundColor = "LightCoral";
			$("#pwdlength_row").removeClass();
			$("#pwdlength_row").addClass('danger');
		}
	
		req = req1 + req2 + req4;		
		if (req >= 23){
			document.getElementById("final_result").innerHTML="VALID"
			document.getElementById("final_result").style.backgroundColor = "PaleGreen";
		}
		else {
			document.getElementById("final_result").innerHTML="INVALID"
			document.getElementById("final_result").style.backgroundColor = "LightCoral";
		}
	});
</script>
</body>
</html>
